list.arraylist

## Class SortableArrayList

- java.lang.Object
- - list.listinterface.BaseList
  - - list.arraylist.BaseArrayList
    - - list.arraylist.LinearArrayList
      - - list.arraylist.SortableArrayList

- All Implemented Interfaces:
    BaseListInterface, CommonBase, List, QueueList, SortableList, StackList

      class SortableArrayList
      extends LinearArrayList
      implements SortableList, List, QueueList, StackList

  Implementace seřaditelného seznamu.

  Popis: implementace seznamu, který umí navíc vyrábět mělké kopie pro potřeby řazení.

  Užití: instance této třídy lze používat v aplikacích.

- - ### Field Summary

    - ### Fields inherited from class list.arraylist.BaseArrayList

      `first, store`

    - ### Fields inherited from class list.listinterface.BaseList

      `moveCounter`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SortableArrayList(int aSize)` Vyrobí seřaditelný seznam.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MemberReference` | `getFirstRef()` Vrátí ukazatel na první člen seznamu.
    `MemberReference` | `getLastRef()` Vrátí odkaz na poslední člen seznamu.
    `ShallowList` | `makeLowerHalfSequence()` Vyrobí mělkou kopii seznamu obsahující spodní polovinu.
    `ShallowList` | `makeShrinkList()` Vyrobí mělkou kopii celého seznamu.
    `ShallowList` | `makeStretchDownList()` Vyrobí mělkou kopii seznamu obsahující posledního člena.
    `ShallowList` | `makeStretchUpList()` Vyrobí mělkou kopii seznamu obsahující prvního člena.
    `ShallowList` | `makeUpperHalfSequence()` Vyrobí mělkou kopii seznamu obsahující horní polovinu.

    - ### Methods inherited from class list.arraylist.LinearArrayList

      `append, getElement, insert, isFirst, isLast, last, moveFirst, moveLast, moveNext, movePrev, moveTo, remove, setElement`

    - ### Methods inherited from class list.arraylist.BaseArrayList

      `getSize`

    - ### Methods inherited from class list.listinterface.BaseList

      `getMoveCounter, resetMoveCounter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface list.listinterface.List

      `insert, isFirst, isLast, moveLast, moveNext, movePrev, moveTo`

    - ### Methods inherited from interface list.listinterface.QueueList

      `append`

    - ### Methods inherited from interface list.listinterface.BaseListInterface

      `getSize, moveFirst, remove`

    - ### Methods inherited from interface list.listinterface.CommonBase

      `getElement, getMoveCounter, resetMoveCounter, setElement`

    - ### Methods inherited from interface list.listinterface.StackList

      `insert`

- - ### Constructor Detail

    - #### SortableArrayList

          public SortableArrayList(int aSize)

      Vyrobí seřaditelný seznam.
      Parameters:
        `aSize` - kapacita seznamu

  - ### Method Detail

    - #### getFirstRef

          public MemberReference getFirstRef()

      Description copied from interface: `SortableList`
      Vrátí ukazatel na první člen seznamu. Dá se porovnat s jiným ukazatelem.
      Specified by:
        `getFirstRef` in interface `SortableList`
      Returns:
        ukazatel na první člen seznamu

    - #### getLastRef

          public MemberReference getLastRef()

      Description copied from interface: `SortableList`
      Vrátí odkaz na poslední člen seznamu. Dá se porovnat s jiným ukazatelem.
      Specified by:
        `getLastRef` in interface `SortableList`
      Returns:
        odkaz na poslední člen seznamu

    - #### makeShrinkList

          public ShallowList makeShrinkList()

      Description copied from interface: `SortableList`
      Vyrobí mělkou kopii celého seznamu.
      Specified by:
        `makeShrinkList` in interface `SortableList`
      Returns:
        mělká kopie celého seznamu

    - #### makeStretchUpList

          public ShallowList makeStretchUpList()

      Description copied from interface: `SortableList`
      Vyrobí mělkou kopii seznamu obsahující prvního člena.
      Specified by:
        `makeStretchUpList` in interface `SortableList`
      Returns:
        mělká kopie seznamu obsahující prvního člena

    - #### makeStretchDownList

          public ShallowList makeStretchDownList()

      Description copied from interface: `SortableList`
      Vyrobí mělkou kopii seznamu obsahující posledního člena.
      Specified by:
        `makeStretchDownList` in interface `SortableList`
      Returns:
        mělká kopie seznamu obsahující posledního člena

    - #### makeLowerHalfSequence

          public ShallowList makeLowerHalfSequence()

      Description copied from interface: `SortableList`
      Vyrobí mělkou kopii seznamu obsahující spodní polovinu.
      Specified by:
        `makeLowerHalfSequence` in interface `SortableList`
      Returns:
        mělká kopie seznamu obsahující spodní polovinu

    - #### makeUpperHalfSequence

          public ShallowList makeUpperHalfSequence()

      Description copied from interface: `SortableList`
      Vyrobí mělkou kopii seznamu obsahující horní polovinu.
      Specified by:
        `makeUpperHalfSequence` in interface `SortableList`
      Returns:
        mělká kopie seznamu obsahující horní polovinu